\documentclass[12pt]{article}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{amssymb}
\usepackage{amsmath}
\usepackage{maple2e} 
\newcommand\emptyline{\vspace{12pt}}
\DefineParaStyle{Maple Output}
\DefineCharStyle{2D Math}
\DefineCharStyle{2D Output}

\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=1cm

\def\Gr{Gr\"obner}
\def\kn{k[x_1,\dots,x_n]}
\def\lc{\mbox{\sc lc}}
\def\lt{\mbox{\sc lt}}
\def\lp{\mbox{\sc lp}}
\def\gcd{\mbox{\sc gcd}}
\def\lcm{\mbox{\sc lcm}}
\def\red#1{\stackrel{#1}{\longrightarrow}}
\def\redplus#1{\stackrel{#1}{\longrightarrow}_+}

\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{corollary}{Corollary}[section]

\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}{8}
\section{Elimination}




\subsection{Elimination Ideals}
\label{elimideal}

The problems introduced in Lecture~1 as a motivation for Buchberger's algorithm
concerned solutions of sets of polynomials in several variables or, to put it
another way, the determination of varieties.  A classical way to approach this
problem is to eliminate variables sequentially until one obtains a polynomial in
only one variable, which may be solved exactly or numerically, and then proceed by
back substitution (or {\it extension\/}).  A good example of this was Q1 in
Assignment~1 (see solutions). The classical route to elimination is via {\it
resultants\/}. However {\Gr} bases give us a nice understanding of what is going on.


Consider the following example:
\begin{eqnarray*}
x^2+y+z&=&1\\
x+y^2+z&=&1\\
x+y+z^2&=&1.
\end{eqnarray*}
It is easy to see that we could eliminate, say $x$, by rearranging the third
equation and substituting in the other two. After that life gets a little trickier as
neither of the resulting equations are linear in either $y$ or $z$.

In algebraic terms we are interested in the ideal
$$
I=\<x^2+y+z-1, x+y^2+z-1, x+y+z^2-1\>.
$$
Let us find a {\Gr} basis using {\sc lex} order with $x>y>z$. You can do this with
Maple as follows:

\begin{maplegroup}
\begin{mapleinput}
\mapleinline{active}{1d}{with(Groebner):}{%
}
\end{mapleinput}
\mapleresult
%\begin{maplelatex}
%\mapleinline{inert}{2d}{[fglm, gbasis, gsolve, hilbertdim, hilbertpoly, hilbertseries,
%inter_reduce, is_finite, is_solvable, leadcoeff, leadmon, leadterm,
%normalf, pretend_gbasis, reduce, spoly, termorder, testorder,
%univpoly];}
%{%
%\[
%\left[\mathit{fglm}, \,\mathit{gbasis}, \,\mathit{gsolve}, \,\mathit{hilbertdim}, \,\mathit{hilbertpoly}, \,\mathit{hilbertseries}, \,\mathit{inter\_reduce}, \,\mathit{is\_finite}, \right. 
%\]
%%
%}
%{%
%\[
%\mathit{is\_solvable}, \,\mathit{leadcoeff}, \,\mathit{leadmon}, \,\mathit{leadterm}, \,\mathit{normalf}, \,\mathit{pretend\_gbasis}, \,\mathit{reduce}, \,\mathit{spoly},  
%\]
%%
%}
%{%
%\[
%\left.\mathit{termorder}, \,\mathit{testorder}, \,\mathit{univpoly}\right] 
%\]
%%
%}
%\end{maplelatex}
\end{maplegroup}
\begin{maplegroup}
\begin{mapleinput}
\mapleinline{active}{1d}{G:=\{x^2+y+z-1,x+y^2+z-1,x+y+z^2-1\};}{%
}
\end{mapleinput}

\mapleresult
\begin{maplelatex}
\mapleinline{inert}{2d}{G := \{x^2+y+z-1, x+y^2+z-1, x+y+z^2-1\};}{%
\[
G := \{x^{2} + y + z - 1, \,x + y^{2} + z - 1, \,x + y + z^{2} - 1\}
\]
%
}
\end{maplelatex}

\end{maplegroup}
\begin{maplegroup}
\begin{mapleinput}
\mapleinline{active}{1d}{gbasis(G,plex(x,y,z));}{%
}
\end{mapleinput}

\mapleresult
\begin{maplelatex}
\mapleinline{inert}{2d}{[4*z^3-4*z^4+z^6-z^2, -z^2+2*y*z^2+z^4, y^2+z-y-z^2, x+y+z^2-1];}{%
\[
[4\,z^{3} - 4\,z^{4} + z^{6} - z^{2}, \, - z^{2} + 2\,y\,z^{2} + 
z^{4}, \,y^{2} + z - y - z^{2}, \,x + y + z^{2} - 1]
\]
%
}
\end{maplelatex}

\end{maplegroup}

Note that the command is {\tt gbasis}, which sits in the library of commands {\tt
Groebner}. Its operands are a set of polynomials and a term order, here described by
{\tt plex(x,y,z)} standing for {\it pure lexicographic\/}. In reverse order and
writing the terms of each polynomial in descending order, we have the basis:
\begin{eqnarray*}
g_1&=&x+y+z^2-1\\
g_2&=&y^2-y-z^2+z\\
g_3&=&2yz^2+z^4-z^2\\
g_4&=&z^6-4z^4+4z^3-z^2.
\end{eqnarray*}
The key is that the last polynomial involves only $z$: $x$ and $y$ have been
eliminated, while the previous two only feature $y$ and $z$. We can solve explicitly
in this case as $g_4$ factorises:
$$
g_4=z^2(z-1)^2(z^2+2z-1)
$$
whence $z=0,1,-1\pm\sqrt2$. Extending solutions back:
\begin{itemize}
\item
$z=0$ in $g_2$ and $g_3$ gives $y=0,1$
\item
$z=1$ in $g_2$ and $g_3$ gives $y=0$
\item
$z=-1\pm\sqrt2$ in $g_2$ and $g_3$ gives $y=-1\pm\sqrt2$
\end{itemize}
Finally, substituting each of these 5 solutions for $(y,z)$ into $g_1$ gives a
unique corresponding solution for $x$ and so the complete set of solutions is:
$$
(x,y,z)=(1,0,0),\;(0,1,0),\;(0,0,1),\;(-1+\sqrt2,-1+\sqrt2,-1+\sqrt2),\;
(-1-\sqrt2,-1-\sqrt2,-1-\sqrt2).
$$

In algebraic terms, $g_4$ is an element of the ideal $I$ and also lies in $\C[z]$,
while $g_2,g_3\in I\cap\bC[y,z]$. Thus, we are interested in the intersection of the
given ideal with the polynomial rings corresponding to elimination of one or more
variables.

\begin{definition}
Given an ideal $I=\<f_1,\dots,f_s\>\in\kn$, the {\bf $j$th  elimination ideal} is
$$
I_j=I\cap k[x_{j+1},\dots,x_n]\subset k[x_{j+1},\dots,x_n].
$$
\end{definition}

It is an easy exercise to check that the $I_j$ are indeed ideals. Using
lexicographic ordering ensures that we can find {\Gr} bases for each of the
elimination ideals.

\begin{theorem}[Elimination Theorem]
\label{elim}
If $G$ is a {\Gr} basis for $I\subset\kn$ with respect to {\sc lex} ordering,
$x_1>x_2>\dots>x_n$, then for $0\leq j<n$,
$G_j=G\cap k[x_{j+1},\dots,x_n]$ is a {\Gr} basis for the $j$th elimination ideal
$I_j$ (if it is non-empty).
\end{theorem}

\begin{proof}
Suppose $f\in I_j$, $f\neq0$. Since $G$ is a {\Gr} basis,
and thinking of $I_j$ as a subset of
$I$, it follows that for some $g_i$, $\lt(g_i)|\lt(f)$. But $f$, and hence $\lt(f)$
do not contain the variables $x_1,\dots,x_j$. The same must be true of $\lt(g_i)$.
But we are using {\sc lex} order so {\it none\/} of
the terms of $g_i$ contain $x_1,\dots,x_j$, whence $g_i\in G_j$. It follows from the
definition that $G_j$ is a {\Gr} basis for $I_j$.
\end{proof}

In some problems, one wishes to eliminate a certain identified subset of the
variables, say $x_{j+1},\dots,x_n$. As we noted in Lecture~9, {\sc lex} ordering
renders the Buchberger Algorithm fairly slow, whereas {\sc degrevlex} is generally
quite fast.  We can take advantage of this by introducing the {\bf $j$th elimination
order} on monomials in $\kn$. This is defined by $x^\ga>_jx^\gb$ if and only if
$$
\ga_1+\dots+\ga_j>\gb_1+\dots+\gb_j\quad\mbox{or}\quad
\ga_1+\dots+\ga_j=\gb_1+\dots+\gb_j\;\mbox{and}\;x^\ga>_{\sc degrevlex}x^\gb.
$$
A version of the Elimination Theorem can easily be stated and proved for this order.


\subsection{Extension}

While the {\Gr} basis technique in Section~\ref{elimideal} gives us bases for the
elimination ideals, the extension process has its own problems.  It is not clear in
advance whether a solution $(a_{j+1},\dots,a_n)\in V(I_j)$ extends to a solution
$(a_j,a_{j+1},\dots,a_n)\in V(I_{j-1})$. Let us consider two examples.

{\bf Example 1.} Consider the equations
\begin{eqnarray*}
x^2&=&y\\
x^2&=&z
\end{eqnarray*}
in $\R[x,y,z]$. We have $I_1=\<y-z\>$ so $(a,a)$ is always a partial solution.
However, now we get full solutions $(\pm\sqrt a,a,a)$ if and only if $a\geq0$. In
this case, the problem could be avoided by working in an algebraically closed field
(i.e. $\C$). 

{\bf Example 2.} Find all solutions to the equations
\begin{eqnarray*}
xy&=&1\\
xz&=&1.
\end{eqnarray*}
It is easy to show that again $I_1=\<y-z\>$. Thus, for any $a$, $(a,a)\in V(I_1)$ is
a {\it partial\/} solution. Note however that there is a full solution $(1/a,a,a)$ if
and only if $a\neq0$. Here is a result which tells us when we can extend a given
solution.

\begin{theorem}[Extension Theorem]
\label{ext}
Suppose $I=\<g_1,\dots,g_s\>\in\C[x_1,\dots,x_n]$ and $I_{j-1}=\<g_1,\dots,g_r\>$.
For each $1\leq i\leq r$ let
$$
g_i=h_i(x_{j+1},\dots,x_n)x_j^{N_i}+\mbox{terms in which $x_j$ has degree $<N_i$}
$$
where $N_i\geq0$ and $h_i\in\C[x_{j+1},\dots,x_n]$ is non-zero. If
$(a_{j+1},\dots,a_n)\in V(I_j)$ is a partial solution such that
$(a_{j+1},\dots,a_n)\notin V(h_1,\dots,h_r)$ then there exists $a_{j}\in\C$ so
that $(a_{j},a_{j+1},\dots,a_n)\in V(I_{j-1})$.
\end{theorem}

The proof if this theorem does not use {\Gr} bases, but another computational technique: resultants.

Note that in the {\Gr} basis for the ideal generated by the equations in Example~1,
we have $g=y.x-1$, whence $h=y$. Then for any partial solution $(a,a)$ we get an
extension unless $a=0$ as we previously observed.

\subsection{Closure}

We would like to determine just how the varieties associated to the elimination ideals $I_j$ of an ideal $I=\<f_1,\dots,f_s\>\subseteq\bC[x_1,\dots,x_n]$ relate to the variety $V=\bV(I)=V(f_1,\dots,f_s)$. Geometrically, this concerns the projection functions $\pi_j:\bC^n\to\bC^{n-j}$, $\pi_j(a_1,\dots,a_n)=(a_{j+1},\dots,a_n)$. First we make the simple observation:
\begin{lemma}
With the above notation, $\pi_j(V)\subseteq\bV(I_j)$.
\end{lemma}
\begin{proof}
Suppose $(a_1,\dots,a_n)\in V$ so that $(a_{j+1},\dots,a_n)\in\pi_j(V)$. If $f\in I_j\subset I=\<f_1,\dots,f_s\>$. Then $f\in I$ so $f=0$ on $V$. But $f$ depends only on $x_{j+1},\dots,x_n$, hence
\[
f(a_{j+1},\dots,a_n)=f(\pi_j(a_1,\dots,a_n))=0
\]
\end{proof}

However, there is a much stronger relationship, namely that $V(I_j)$ is the {\em smallest} variety containing the image $\pi_j(V)$.  In order to prove this we need a stronger theorem due to Hilbert.  


\end{document}
